Bug 1018223 - Fix and enhance the performance of Infinispan Binary Store's ChunkInputStream
Fix and enhance the performance of Infinispan Binary Store's ChunkInputStream
Status: CLOSED CURRENTRELEASE
Product: JBoss Data Virtualization 6
Classification: JBoss
Component: ModeShape (Show other bugs)
6.0.0
Unspecified Unspecified
unspecified Severity high
: ER3
: ---
Assigned To: Horia Chiorean
: QA-Closed
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-10-11 09:45 EDT by Horia Chiorean
Modified: 2016-02-10 03:59 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-02-10 03:59:44 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)


External Trackers
Tracker ID Priority Status Summary Last Updated
JBoss Issue Tracker MODE-1752 Critical Closed Improve skip(...) performance in InputStream of InfinispanBinaryStore 2014-02-18 07:46:24 EST

  None (edit)
Description Horia Chiorean 2013-10-11 09:45:45 EDT
The current ChunkInputStream implementation:
a) incorrectly implements the skip() operation, potentially causing corrupt data to be read
b) when multiple chunks are present, uses a sequential algorithm for moving across chunks during the skip operation.

These 2 issues should be fixed.
Comment 1 JBoss JIRA Server 2013-10-15 12:34:31 EDT
Horia Chiorean <hchiorea@redhat.com> made a comment on jira MODE-1752

The information that allowed "direct" streaming was already present in the Metadata and the chunk streams: the size of a chunk, the number of chunks and the total size of the binary. Therefore, the change is 100% backwards compatible.

This PR contains 2 commits:
- one which fixes and implements the direct skipping mechanism
- one which exposes the "chunkSize" as a JSON and AS7 configuration property, allowing clients to "fine-tune" their ISPN binary storage if needed.
Comment 2 JBoss JIRA Server 2013-10-15 12:34:47 EDT
Horia Chiorean <hchiorea@redhat.com> made a comment on jira MODE-1752

The information that allowed "direct" skipping was already present in the Metadata and the chunk streams: the size of a chunk, the number of chunks and the total size of the binary. Therefore, the change is 100% backwards compatible.

This PR contains 2 commits:
- one which fixes and implements the direct skipping mechanism
- one which exposes the "chunkSize" as a JSON and AS7 configuration property, allowing clients to "fine-tune" their ISPN binary storage if needed.
Comment 3 JBoss JIRA Server 2013-10-15 15:08:20 EDT
Randall Hauch <rhauch@jboss.org> made a comment on jira MODE-1752

Rebased and merged into the 'master' branch. Leaving this issue open until it can be merged into the 3.3.x-prod-ip6.0 branch.
Comment 6 JBoss JIRA Server 2013-10-24 05:22:06 EDT
Randall Hauch <rhauch@jboss.org> updated the status of jira MODE-1752 to Closed
Comment 7 belong 2013-11-17 22:05:36 EST
Fixed before GA of major release - setting to requires_doc_text- accordingly

Note You need to log in before you can comment on or make changes to this bug.